/* primitives use by the "greater" functions */

#define bossa_list_entry(x) list_entry(x,PROTOCOL_BOSSA_STRUCT,list_info)

static inline int first_lifo(struct list_head *q,
			     PROTOCOL_BOSSA_STRUCT *p1,
			     PROTOCOL_BOSSA_STRUCT *p2) {
  struct list_head *ptr;
  PROTOCOL_BOSSA_STRUCT *x = NULL; // avoid compiler warnings
  list_for_each(ptr,q) {
    x = bossa_list_entry(ptr);
    if (x == p1 || x == p2) break;
  }
  return x == p1;
}

#define first_fifo first_lifo

/*
static inline int first_lifo_ar(PROTOCOL_BOSSA_STRUCT *q,
				PROTOCOL_BOSSA_STRUCT *p1,
				PROTOCOL_BOSSA_STRUCT *p2) {
  int i=0;
  PROTOCOL_BOSSA_STRUCT *ptr = q[0].next;
  while (ptr != p1 && ptr != p2) {
    if (ptr == &q[i]) {
      i++;
      ptr = q[i].next;
    }
    else ptr = ptr->next;
  }
  return ptr == p1;
}
*/

#define first_fifo_ar first_lifo_ar

#ifdef PROCESS_SCHEDULER
static int count_var(PROTOCOL_PROCESS_STRUCT *p);
static int count_queue(struct list_head *q);
#endif

